#include "server.h"
#include <iostream>
#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>
//#include <stdlib.h>
#include "varia.h"
#include <time.h>
#include <stdlib.h>

using namespace std;

// SDL variables
// keyboard handling

  extern time_t t;

  GLuint *TexSpace;

  SDL_Event controls;

struct caminfo
{
  GLfloat camx;
  GLfloat camy;
  GLfloat camz;
  GLfloat dirx;
  GLfloat diry;
  GLfloat dirz;
  GLfloat upx;
  GLfloat upy;
  GLfloat upz;
};

GLfloat ambient[] = {0.0,0.0,0.0,1.0};

GLfloat difflit[] = {0.99,0.99,0.99,1.0};

GLfloat difflitamb[] = {0.0,0.0,0.0,1.0};

GLfloat difflitpos[] = {0.0,200.0,-200.0,1.0};

caminfo caminfo = {-16.0,32.0,-16.0,0.0,0.0,0.0,0.0,1.0,0.0};

//make the client
  LocalClient::LocalClient(int MinimumClientTime,tile **MapData,
              short **HeightData,int vecx,int vecz,
              int posx, int posz,int sizez,int sizex)
    {
    //set the size of the drawing patch
            
    vec_x = vecx;
    vec_z = vecz;
    
    pos_x = posx;
    pos_z = posz;
    
    Heights = HeightData;
    
    size_x = sizex;
    size_z = sizez;

    vec_x < 2?vec_x = 2:vec_x = vec_x;
    vec_x > 100?vec_x = 100:vec_x = vec_x;

    vec_z < 2?vec_z = 2:vec_z = vec_z;
    vec_z > 100?vec_z = 100:vec_z = vec_z;

    
    //create the normal filter table
    
    showgrid = false;
    showtris = false;
    
    // angle
    angle = 0.0;
    
    // reset timers
    CurrentMs = 0;
    ClientTime = MinimumClientTime;
    Map = MapData;

    VertexTable = NULL;
    ColorTable = NULL;
    NormalTable = NULL;
    TextureTable = NULL;

    //zero commands
    for (int x = 0;x<5;x++)
      {
        commands[x].code = 0;
      };

    perspective = 0;

    // zero keyboard
    keyboard.ESC = 0;
    keyboard.F1 = 0;
    keyboard.F2 = 0;
    keyboard.F3 = 0;
    keyboard.F4 = 0;
    keyboard.F5 = 0;
    keyboard.F6 = 0;
    keyboard.F7 = 0;
    keyboard.F8 = 0;
    keyboard.F9 = 0;
    keyboard.F10 = 0;
    keyboard.F11 = 0;
    keyboard.F12 = 0;
    keyboard.PrintScreen = 0;
    keyboard.ScrollLock = 0;
    keyboard.Pause = 0;
    keyboard.Tilde = 0;
    keyboard.One = 0;
    keyboard.Two = 0;
    keyboard.Three = 0;
    keyboard.Four = 0;
    keyboard.Five = 0;
    keyboard.Six = 0;
    keyboard.Seven = 0;
    keyboard.Eight = 0;
    keyboard.Nine = 0;
    keyboard.Zero = 0;
    keyboard.Minus = 0;
    keyboard.Plus = 0;
    keyboard.Backspace = 0;
    keyboard.Tab = 0;
    keyboard.A = 0;
    keyboard.B = 0;
    keyboard.C = 0;
    keyboard.D = 0;
    keyboard.E = 0;
    keyboard.F = 0;
    keyboard.G = 0;
    keyboard.H = 0;
    keyboard.I = 0;
    keyboard.J = 0;
    keyboard.K = 0;
    keyboard.L = 0;
    keyboard.M = 0;
    keyboard.N = 0;
    keyboard.O = 0;
    keyboard.Q = 0;
    keyboard.P = 0;
    keyboard.R = 0;
    keyboard.S = 0;
    keyboard.T = 0;
    keyboard.U = 0;
    keyboard.V = 0;
    keyboard.W = 0;
    keyboard.X = 0;
    keyboard.Y = 0;
    keyboard.Z = 0;
    keyboard.CapsLock = 0;
    keyboard.LeftBracket = 0;
    keyboard.RightBracket = 0;
    keyboard.BackSlash = 0;
    keyboard.Semicolon = 0;
    keyboard.Quote = 0;
    keyboard.Enter = 0;
    keyboard.LeftShift = 0;
    keyboard.Less = 0;
    keyboard.More = 0;
    keyboard.Slash = 0;
    keyboard.RightShift = 0;
    keyboard.LeftControl = 0;
    keyboard.RightControl = 0;
    keyboard.LeftAlt = 0;
    keyboard.RightAlt = 0;
    keyboard.Space = 0;
    keyboard.Insert = 0;
    keyboard.Delete = 0;
    keyboard.Home = 0;
    keyboard.End = 0;
    keyboard.PageUp = 0;
    keyboard.PageDown = 0;
    keyboard.UpArrow = 0;
    keyboard.DownArrow = 0;
    keyboard.LeftArrow = 0;
    keyboard.RightArrow = 0;
    keyboard.NumLock = 0;
    keyboard.KpSlash = 0;
    keyboard.KpStar = 0;
    keyboard.KpMinus = 0;
    keyboard.KpPlus = 0;
    keyboard.KpEnter = 0;
    keyboard.Kp0 = 0;
    keyboard.Kp1 = 0;
    keyboard.Kp2 = 0;
    keyboard.Kp3 = 0;
    keyboard.Kp4 = 0;
    keyboard.Kp5 = 0;
    keyboard.Kp6 = 0;
    keyboard.Kp7 = 0;
    keyboard.Kp8 = 0;
    keyboard.Kp9 = 0;
    keyboard.KpDel = 0;
    keyboard.WinLeft = 0;
    keyboard.WinRight = 0;
    keyboard.WinMenu = 0;

    //sdl initialisation
    SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
    SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
    SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
    SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
    SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

    SDL_WM_SetCaption("Transport Empire Terrain Proto",NULL);

    //create 800/600 window
    SDL_SetVideoMode(800, 600, 32, SDL_OPENGL);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity(); // zero projection matrix

    glEnable(GL_CULL_FACE); // don't draw invisible
    glEnable(GL_DEPTH_TEST); // zbuffer
    
    glPolygonMode(GL_FRONT_AND_BACK,GL_FILL); // draw only fronts

    glEnable(GL_LIGHTING); // use light
    glEnable(GL_COLOR_MATERIAL); //include surface color in
                                 //light calculations
                                 
    glEnableClientState (GL_VERTEX_ARRAY); //enable vertex array
    glEnableClientState (GL_COLOR_ARRAY); //enable color array
    glEnableClientState (GL_NORMAL_ARRAY); //enable normals array
    glEnableClientState (GL_TEXTURE_COORD_ARRAY); //enable texture coord array

    glEnable(GL_TEXTURE_2D);// use textures
    glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE); //oh yes - and lightning

    //all set - lets go

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glViewport(0,0,800,600);

    glFlush();
    SDL_GL_SwapBuffers();
    
    //now create the ground texture
    
    TexSpace = new GLuint[1];
    
    Texture = new char[tex_size*tex_size*3];
    
    srand(unsigned(time(&t)) + SDL_GetTicks());

    char m;

    for (int x = 0;x < tex_size;x++)
      for (int z = 0;z < tex_size*3;z++)
        {
          m = rand()%70+100;
          Texture[(x*tex_size+z/3)*3] = m;
          Texture[(x*tex_size+z/3)*3+1] = m;
          Texture[(x*tex_size+z/3)*3+2] = m;
        }

    for (int x = 0;x < tex_size*3;x+=3)
      {
        Texture[x] = 50;
        Texture[x+1] = 50;
        Texture[x+2] = 50;
        Texture[x+tex_size*(tex_size-1)*3] = 50;
        Texture[x+tex_size*(tex_size-1)*3+1] = 50;
        Texture[x+tex_size*(tex_size-1)*3+2] = 50;
      }  

    for (int x = 0;x < tex_size*tex_size*3;x+=tex_size*3)
      {
        Texture[x] = 50;
        Texture[x+1] = 50;
        Texture[x+2] = 50;
        Texture[x+(tex_size-1)*3] = 50;
        Texture[x+(tex_size-1)*3+1] = 50;
        Texture[x+(tex_size-1)*3+2] = 50;
      }


//    for (int x = 0;x < tex_size*tex_size*3;x++)
//      cout << int(Texture[x]) << " ";
    
    glGenTextures(1, &TexSpace[0]);
    
    glBindTexture(GL_TEXTURE_2D, TexSpace[0]);    
  
    glTexImage2D(GL_TEXTURE_2D,0,3,tex_size,
                tex_size,0,GL_RGB,GL_UNSIGNED_BYTE,
                Texture);
    
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    gluBuild2DMipmaps(GL_TEXTURE_2D,3,tex_size,tex_size,GL_RGB,GL_UNSIGNED_BYTE,Texture);
    glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);


    CreateArrays();
  };

//kill the client    
LocalClient::~LocalClient(void)
  {
    delete[] Texture;
  };

//draw the contents
bool LocalClient::Draw()
  {
  //drawing something here
 
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if (perspective)
    {
      gluPerspective(45,1.0,1.0,3000.0);
    }
    else
    {
      glOrtho(-16.0,16.0,-16.0,16.0,-20.0,300.0);
    }
    
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);  

    glClearColor(0.4,0.3,0.2,1.0);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    gluLookAt(caminfo.camx,caminfo.camy,caminfo.camz,
              caminfo.dirx,caminfo.diry,caminfo.dirz,
              caminfo.upx,caminfo.upy,caminfo.upz);

//    glRotatef(rot,0.0,1.0,0.0);

    glLightfv(GL_LIGHT0,GL_DIFFUSE,difflit);
    glLightfv(GL_LIGHT0,GL_AMBIENT,difflitamb);
    glLightfv(GL_LIGHT0,GL_POSITION,difflitpos);

    glEnable(GL_LIGHT0);
 
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    gluLookAt(caminfo.camx,caminfo.camy,caminfo.camz,
              caminfo.dirx,caminfo.diry,caminfo.dirz,
              caminfo.upx,caminfo.upy,caminfo.upz);

    glRotatef(angle,0.0,1.0,0.0);

//    rot += 0.5;

    if (angle > 360)
      {
        angle -= 360;
      }
      
    if (angle < 0)
      {
        angle += 360;
      }  

//    glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);

    DrawTerrain();

    RysujUklad(25);

    glFlush();

    SDL_GL_SwapBuffers();

    cout << 40-ClientLimit+SDL_GetTicks() - AbsoluteTime << " ";

    while(!CheckEnd())
      {

      };
  //wait until the rest of our time passes
  };

//determine the commands
void LocalClient::TestControls(void)
  {
    for (int x = 0;x < 2;x++) // test the controls two
                              // times per frame
      {
        if (SDL_PollEvent(&controls))
          {
            switch (controls.type)
              {
                case SDL_KEYDOWN:
                    switch(controls.key.keysym.sym)
                      {
                        case SDLK_ESCAPE:
                          {
                            keyboard.ESC = 1;
                            break;
                          }
                        case SDLK_g:
                          {
                            if (showgrid) showgrid=0; else showgrid=1;
                            break;
                          }
                        case SDLK_t:
                          {
                            if (showtris) showtris=0; else showtris=1;
                            break;
                          }
                        case SDLK_1:
                          {
                            keyboard.One = 1;
                            break;
                          }
                        case SDLK_2:
                          {
                            keyboard.Two = 1;
                            break;
                          } 
                        case SDLK_3:
                          {
                            keyboard.Three = 1;
                            break;
                          }
                        case SDLK_4:
                          {
                            keyboard.Four = 1;
                            break;
                          }
                        case SDLK_SPACE:
                          {
                            keyboard.Space = 1;
                            break;
                          }
                        case SDLK_UP:
                          {
                            keyboard.UpArrow = 1;
                            break;
                          }
                        case SDLK_DOWN:
                          {
                            keyboard.DownArrow = 1;
                            break;
                          }
                        case SDLK_EQUALS:
                          {
                            keyboard.Plus = 1;
                            break;
                          }
                        case SDLK_MINUS:
                          {
                            keyboard.Minus = 1;
                            break;
                          }
                        case SDLK_LEFTBRACKET:
                          {
                            keyboard.LeftBracket = 1;
                            break;
                          }
                        case SDLK_RIGHTBRACKET:
                          {
                            keyboard.RightBracket = 1;
                            break;
                          }
                        case SDLK_p:
                          {
                            keyboard.P = 1;
                            break;
                          }
                      };
                break;

                case SDL_KEYUP:
                    switch(controls.key.keysym.sym)
                      {
                        case SDLK_ESCAPE:
                          {
                            keyboard.ESC = 0;
                          }
                        case SDLK_1:
                          {
                            keyboard.One = 0;
                            break;
                          }
                        case SDLK_2:
                          {
                            keyboard.Two = 0;
                            break;
                          }  
                        case SDLK_3:
                          {
                            keyboard.Three = 0;
                            break;
                          }
                        case SDLK_4:
                          {
                            keyboard.Four = 0;
                            break;
                          }
                        case SDLK_SPACE:
                          {
                            keyboard.Space = 0;
                            break;
                          }
                        case SDLK_UP:
                          {
                            keyboard.UpArrow = 0;
                            break;
                          }
                        case SDLK_DOWN:
                          {
                            keyboard.DownArrow = 0;
                            break;
                          }
                        case SDLK_EQUALS:
                          {
                            keyboard.Plus = 0;
                            break;
                          }
                        case SDLK_MINUS:
                          {
                            keyboard.Minus = 0;
                            break;
                          };
                        case SDLK_LEFTBRACKET:
                          {
                            keyboard.LeftBracket = 0;
                            break;
                          }
                        case SDLK_RIGHTBRACKET:
                          {
                            keyboard.RightBracket = 0;
                            break;
                          }
                        case SDLK_p:
                          {
                            keyboard.P = 0;
                            break;
                          }
                      };
                break;

                default:
                  x = 2;
                break;
              };
          };
      };
    MakeCommands();  
  };


//checks if the time needed to draw had elapsed    
bool LocalClient::CheckEnd (void)
    {
        CurrentMs = int(SDL_GetTicks() - AbsoluteTime);
        if (CurrentMs >= ClientLimit)
          return true;
          else
          return false;
    };
    
       
// start client clock
void LocalClient::StartClientClock(int Bonus)
    {
        ClientLimit = Bonus + ClientTime;
        CurrentMs = 0;
        AbsoluteTime = SDL_GetTicks();
    }; 
    
// determine what to do (commands, view changes etc);
void LocalClient::MakeCommands(void)
  {
    if(keyboard.ESC)
    {
      SetCommands(1,0,0,0,0); // command 1 - excape
    }

    if(keyboard.One)
    {
      SetCommands(2,1,0,0,0); // command 2 par 1 - increase edge
    }

    if(keyboard.Two)
    {
      SetCommands(2,2,0,0,0); // command 2 par 2 - decrease edge
    }

    if(keyboard.Three)
    {
      SetCommands(2,3,0,0,0); // command 2 par 3 - increase amplitude
    }

    if(keyboard.Four)
    {
      SetCommands(2,4,0,0,0); // command 2 par 3 - decrese amplitude
    }
    
    if(keyboard.Space)
    {
      SetCommands(3,0,0,0,0); //command 3 - creat new terrain
      keyboard.Space = 0;
    }
    
    if(keyboard.UpArrow)
    {
      //dev_vec_x += 2;
    }
    
    if(keyboard.DownArrow)
    {
      //dev_vec_x -= 2;
    }
    
    if(keyboard.Plus)
    {
      /*if ((vec_x < 128) && (vec_z < 128))
      {

      caminfo.camx -=2.5;
      caminfo.camy +=5.0;
      caminfo.camz -=2.5;
      
      vec_z += 4;
      vec_x += 4;
      
      CreateArrays();
      keyboard.Plus = 0;
      }*/
    }  

    if(keyboard.Minus)
    {
      
      /*if ((vec_x > 4) && (vec_z > 4))
      {
        caminfo.camx +=2.5;
        caminfo.camy -=5.0;
        caminfo.camz +=2.5;

        vec_z -= 4;
        vec_x -= 4;
  
        CreateArrays();
        keyboard.Minus = 0;
      }*/  
    }
    
    if(keyboard.LeftBracket)
    {
      angle -= 2;
    }
    
    if(keyboard.RightBracket)
    {
      angle += 2;
    };
    
    if(keyboard.P)
    {
      if (perspective == 1)
        {   
          perspective = 0;
          keyboard.P = 0;
        }
      else
        {
            perspective = 1;
            keyboard.P = 0;
        }
    };
    
  }
  
// set commands

void LocalClient::SetCommands(int code,int par1,int par2,int par3,int par4)
  {
    for(int u = 0;u < 5;u++)
      {
        if(commands[u].code == 0)
          {
            commands[u].code = code;
            commands[u].par1 = par1;
            commands[u].par2 = par2;
            commands[u].par3 = par3;
            commands[u].par4 = par4;
            u = 5;
          }
      }
  }
  
//draw terrain

void LocalClient::DrawTerrain()
  {
//    cout << "\n----------\ndvx " << dev_vec_x << " dvz " << dev_vec_z;
//    cout << "\npx " << pos_x << " pz " << pos_z;
//    cout << "\nvx " << vec_x << " vz " << vec_z;
//    cout << "\ntpx " << tot_pos_x << " tpz " << tot_pos_z;
//    cout << "\ntvx " << tot_vec_x << " tvz " << tot_vec_z << "\n----------\n";

//    CreateArrays();

      glCallList(1);
//    glDrawArrays (GL_TRIANGLES,0,tot_vec_x*tot_vec_z*6);
  }

//create vertex/normal/color arrays
// stages:
// 1 - determine the patch size
// 2 - determine patch size with borders included
// 3 - position the patch
// 4 - determine camera central point
// 5 - send it to the GL arrays


void LocalClient::CreateArrays()
  {
    // delete display list
    
    glDeleteLists(1,1);
    
    // delete vertex table
    
    if (VertexTable != NULL)
      {
        delete[]VertexTable;
      }
    
    // delete color table
    
    if (ColorTable != NULL)
      {
        delete[]ColorTable;
      }
    
    //delete normal table
    
    if (NormalTable != NULL)
      {
        delete[]NormalTable;
      }
    
    //delete texture table  
    if (TextureTable != NULL)
      {
        delete[]TextureTable;
      }    
    
    //stage 1
    
    //check if the positon and size are not correct in size
    
    if (pos_x < 0) pos_x = 0;
    if (pos_z < 0) pos_z = 0;

    if (vec_x < 4) vec_x = 4;
    if (vec_z < 4) vec_z = 4;
    
    //check if the size of the displayed patch is not too big
    //(bigger then the map)
    // if so - we display the whole map,
    
    if (vec_x > size_x) vec_x = size_x;
    if (vec_z > size_z) vec_z = size_z;

    // check if the positon of the patch with patch size
    // is not bigger then the map

    if (pos_x+vec_x > size_x) pos_x = size_x - vec_x;
    if (pos_z+vec_z > size_z) pos_z = size_z - vec_z;
    
    //cout << "\n pos " << pos_x << " " << pos_z;
    //cout << "\n vec " << vec_x << " " << vec_z;
    
    // known - now we need to determine the super-patch size
    // meaning: the patch with borders.

    // the size of the border is 9 patches unless it
    // cannot be that large :)
    
    tot_pos_x = int(pos_x-vec_x);
    tot_pos_z = int(pos_z-vec_z);
    
    // done :)
    // now determine total vector - which is double of the
    // vector specified
    
    tot_vec_x = vec_x*3;
    tot_vec_z = vec_z*3;
    
    // now - if tot-pos is smaller then zero then zero it
    // pretty much the same stuff as for the pos and vec
    
    if (tot_pos_x < 0) tot_pos_x = 0;
    if (tot_pos_z < 0) tot_pos_z = 0;
        
    // ok - now check if the total vector is not above size
    // of the map
    
    if (tot_vec_x > size_x) tot_vec_x = size_x;
    if (tot_vec_z > size_z) tot_vec_z = size_z;
    
    // now - check if tot_pos and tot_vec combined are within
    // the map boundries
    
    if (tot_pos_x+tot_vec_x > size_x) tot_pos_x = size_x - tot_vec_x;
    if (tot_pos_z+tot_vec_z > size_z) tot_pos_z = size_z - tot_vec_z;
    
//    cout << "\n pos " << pos_x << " " << pos_z;
//    cout << "\n vec " << vec_x << " " << vec_z;

//    cout << "\n tot pos " << tot_pos_x << " " << tot_pos_z;
//    cout << "\n tot vec " << tot_vec_x << " " << tot_vec_z << "\n";
    
    //done
    
    // stage 2
    // sizes set, now to make the tables

    // create vertex array
    
    int offset = 18;
    
    VertexTable = new float[tot_vec_x*tot_vec_z*offset];
    
    // create color array  

    ColorTable = new float[tot_vec_x*tot_vec_z*offset];

    // create normal array
    
    NormalTable = new float[tot_vec_x*tot_vec_z*offset];
    
    // create texture coord table
    
    TextureTable = new float[tot_vec_x*tot_vec_z*int(offset/3*2)];

    // tables created. Now fill them with data
    // vertices first. I will use triangles here, with
    // normal and color for each vertex

    int ind;
    int ind2;
    int w1;
    int w2;

    float size_x_half = tot_vec_x/2.0;
    float size_z_half = tot_vec_z/2.0;
    
//    cout << size_x_half << " " << size_z_half << "\n";

    //system("pause");
    
    int v = tot_vec_z*offset;
    
    for (int x = 0;x < tot_vec_x;x++)
      for (int z = 0;z < v;z+=offset)
        {
          ind = ((x*tot_vec_z)+z/offset)*offset;
          ind2 = int(z/offset);
    //      cout << x << " " << ind2 << "\n";
          w1 = Heights[x+tot_pos_x][ind2+tot_pos_z]+Heights[x+1+tot_pos_x][ind2+1+tot_pos_z];
          w2 = Heights[x+1+tot_pos_x][ind2+tot_pos_z]+Heights[x+tot_pos_x][ind2+1+tot_pos_z];
          w1 = w1/2;
          w2 = w2/2;
          if (w1 >= w2)
            {
                  VertexTable[ind+0] = x-size_x_half;
                  VertexTable[ind+1] = Heights[x+tot_pos_x][ind2+1+tot_pos_z]/160.0;
                  VertexTable[ind+2] = 1+ind2-size_z_half;
    
                  VertexTable[ind+3] = 1+x-size_x_half;
                  VertexTable[ind+4] = Heights[x+1+tot_pos_x][ind2+1+tot_pos_z]/160.0;
                  VertexTable[ind+5] = 1+ind2-size_z_half;
    
                  VertexTable[ind+6] = x-size_x_half;
                  VertexTable[ind+7] = Heights[x+tot_pos_x][ind2+tot_pos_z]/160.0;
                  VertexTable[ind+8] = ind2-size_z_half;
    
                  VertexTable[ind+9] = 1+x-size_x_half;
                  VertexTable[ind+10] = Heights[x+1+tot_pos_x][ind2+tot_pos_z]/160.0;
                  VertexTable[ind+11] = ind2-size_z_half;

                  VertexTable[ind+12] = x-size_x_half;
                  VertexTable[ind+13] = VertexTable[ind+7];
                  VertexTable[ind+14] = ind2-size_z_half;

                  VertexTable[ind+15] = 1+x-size_x_half;
                  VertexTable[ind+16] = VertexTable[ind+4];
                  VertexTable[ind+17] = 1+ind2-size_z_half;
            }  
          else
            {
                  VertexTable[ind+0] = x-size_x_half;
                  VertexTable[ind+1] = Heights[x+tot_pos_x][ind2+tot_pos_z]/160.0;
                  VertexTable[ind+2] = ind2-size_z_half;

                  VertexTable[ind+3] = x-size_x_half;
                  VertexTable[ind+4] = Heights[x+tot_pos_x][ind2+1+tot_pos_z]/160.0;
                  VertexTable[ind+5] = 1+ind2-size_z_half;

                  VertexTable[ind+6] = 1+x-size_x_half;
                  VertexTable[ind+7] = Heights[x+1+tot_pos_x][ind2+tot_pos_z]/160.0;
                  VertexTable[ind+8] = ind2-size_z_half;
    
                  VertexTable[ind+9] = 1+x-size_x_half;
                  VertexTable[ind+10] = Heights[x+1+tot_pos_x][ind2+1+tot_pos_z]/160.0;
                  VertexTable[ind+11] = 1+ind2-size_z_half;

                  VertexTable[ind+12] = 1+x-size_x_half;
                  VertexTable[ind+13] = VertexTable[ind+7];
                  VertexTable[ind+14] = ind2-size_z_half;

                  VertexTable[ind+15] = x-size_x_half;
                  VertexTable[ind+16] = VertexTable[ind+4];
                  VertexTable[ind+17] = 1+ind2-size_z_half;

            }
        }

    // color table

    float dived = 15.0;
    float color = 0.7;
    float red = 1.0;
    float green = 1.0;
    float blue = 1.0;

    int u = tot_vec_x*tot_vec_z*offset;

    for (int z = 0;z < u;z+=3)
        {
          ind = z/3*3;
          
//          cout << ind;

          red = LC(VertexTable[ind+1]/dived,color);
          green = color-0.05;
          blue = red;

          if (VertexTable[ind+1] == 0)
            {
              red = 0.0;
              green = 0.5;
              blue = 1.0;
            }  
          

          
          ColorTable[ind] = red;
          ColorTable[ind+1] = green;
          ColorTable[ind+2] = blue;
        }  
          
    
    // now normals O_o
    // note Normals table is created - such way, so
    // there will be no problems with non square maps

    Normals = new NormalVector*[tot_vec_z+1];
    for (int z = 0;z < tot_vec_x+1;z++)
      {
        Normals[z] = new NormalVector[tot_vec_x+1];
      };  

    for (int x = 1;x < tot_vec_x-1;x++)
      for (int z = 1;z < tot_vec_z-1;z++)
        {
          vector1[0] = 2;
          vector1[1] = Heights[x+1+tot_pos_x][z+tot_pos_z]/160.0 - Heights[x-1+tot_pos_x][z+tot_pos_z]/160.0;
          vector1[2] = 0;

          vector2[0] = 0;
          vector2[1] = Heights[x+tot_pos_x][z+1+tot_pos_z]/160.0 - Heights[x+tot_pos_x][z-1+tot_pos_z]/160.0;
          vector2[2] = 2;
         
          FindNormal();
          
          Normals[x][z].a = normal[0];
          Normals[x][z].b = normal[1];
          Normals[x][z].c = normal[2];
//          cout << x << " " << z << "\n";
        }  

   for(int u = 0;u < 2;u++)
    for (int x = 1;x < tot_vec_x-1;x++)
      for (int z = 1;z < tot_vec_z-1;z++)
       {
          FilterNormals(Normals[x-1][z],
                        Normals[x+1][z],
                        Normals[x][z],
                        Normals[x][z-1],
                        Normals[x][z+1]);

            Normals[x][z].a = normal[0];
            Normals[x][z].b = normal[1];
            Normals[x][z].c = normal[2];
        };

    for (int x = 0;x < tot_vec_x;x++)
      for (int z = 0;z < v;z+=offset)
        {
          ind = ((x*tot_vec_z)+z/offset)*offset;
          ind2 = int(z/offset);
          if (
              ((Heights[x+tot_pos_x][ind2+tot_pos_z]+Heights[x+1+tot_pos_x][ind2+1+tot_pos_z])/2)
              >=
              ((Heights[x+1+tot_pos_x][ind2+tot_pos_z]+Heights[x+tot_pos_x][ind2+1+tot_pos_z])/2)
             )
            {
                  NormalTable[ind+0] = Normals[x][ind2+1].a;
                  NormalTable[ind+1] = Normals[x][ind2+1].b;
                  NormalTable[ind+2] = Normals[x][ind2+1].c;
    
                  NormalTable[ind+3] = Normals[x+1][ind2+1].a;
                  NormalTable[ind+4] = Normals[x+1][ind2+1].b;
                  NormalTable[ind+5] = Normals[x+1][ind2+1].c;;
    
                  NormalTable[ind+6] = Normals[x][ind2].a;
                  NormalTable[ind+7] = Normals[x][ind2].b;
                  NormalTable[ind+8] = Normals[x][ind2].c;
    
                  NormalTable[ind+9] = Normals[x+1][ind2].a;
                  NormalTable[ind+10] = Normals[x+1][ind2].b;
                  NormalTable[ind+11] = Normals[x+1][ind2].c;

                  NormalTable[ind+12] = NormalTable[ind+6];
                  NormalTable[ind+13] = NormalTable[ind+7];
                  NormalTable[ind+14] = NormalTable[ind+8];

                  NormalTable[ind+15] = NormalTable[ind+3];
                  NormalTable[ind+16] = NormalTable[ind+4];
                  NormalTable[ind+17] = NormalTable[ind+5];
            }  
          else
            {
                  NormalTable[ind+0] = Normals[x][ind2].a;
                  NormalTable[ind+1] = Normals[x][ind2].b;
                  NormalTable[ind+2] = Normals[x][ind2].c;

                  NormalTable[ind+3] = Normals[x][ind2+1].a;
                  NormalTable[ind+4] = Normals[x][ind2+1].b;
                  NormalTable[ind+5] = Normals[x][ind2+1].c;

                  NormalTable[ind+6] = Normals[x+1][ind2].a;
                  NormalTable[ind+7] = Normals[x+1][ind2].b;
                  NormalTable[ind+8] = Normals[x+1][ind2].c;
    
                  NormalTable[ind+9] = Normals[x+1][ind2+1].a;
                  NormalTable[ind+10] = Normals[x+1][ind2+1].b;
                  NormalTable[ind+11] = Normals[x+1][ind2+1].c;

                  NormalTable[ind+12] = NormalTable[ind+6];
                  NormalTable[ind+13] = NormalTable[ind+7];
                  NormalTable[ind+14] = NormalTable[ind+8];

                  NormalTable[ind+15] = NormalTable[ind+3];
                  NormalTable[ind+16] = NormalTable[ind+4];
                  NormalTable[ind+17] = NormalTable[ind+5];
            }
        }

    for (int z = 0;z < tot_vec_x;z++)
      {
        delete[]Normals[z];
      }
    delete[]Normals;  

    for (int x = 0;x < tot_vec_x*tot_vec_z*12;x+=12)
      {
         TextureTable[x+0] = 0.0;
         TextureTable[x+1] = 0.0;

         TextureTable[x+2] = 1.0;
         TextureTable[x+3] = 0.0;

         TextureTable[x+4] = 0.0;
         TextureTable[x+5] = 1.0;

         TextureTable[x+6] = 1.0;
         TextureTable[x+7] = 1.0;

         TextureTable[x+8] = 0.0;
         TextureTable[x+9] = 1.0;

         TextureTable[x+10] = 1.0;
         TextureTable[x+11] = 0.0;
      }
    
    //assingn pointers
    
    glBindTexture(GL_TEXTURE_2D, TexSpace[0]);
    
    glVertexPointer(3,GL_FLOAT,0,VertexTable);
    glColorPointer(3,GL_FLOAT,0,ColorTable);
    glNormalPointer(GL_FLOAT,0,NormalTable);
    glTexCoordPointer(2,GL_FLOAT,0,TextureTable);
    
    glNewList(1,GL_COMPILE);
    glDrawArrays (GL_TRIANGLES,0,tot_vec_x*tot_vec_z*6);
    glEndList();
  }
  
//find the normal vector

void LocalClient::FindNormal(void)
  {
    normal[0] = vector1[2]*vector2[1] - vector1[1]*vector2[2];
    normal[1] = vector1[0]*vector2[2] - vector1[2]*vector2[0];
    normal[2] = vector1[1]*vector2[0] - vector1[0]*vector2[1];
    
    // now - normalize the normal to 1 :)
    
    float length = sqrt(normal[0]*normal[0]+normal[1]*normal[1]+normal[2]*normal[2]);

    normal[0] /= length;
    normal[1] /= length;
    normal[2] /= length;
  }

void LocalClient::FilterNormals (NormalVector vec1,NormalVector vec2,NormalVector vec3,NormalVector vec4,NormalVector vec5)
  {
    normal[0] = vec1.a+vec2.a+vec3.a+vec4.a+vec5.a;
    normal[1] = vec1.b+vec2.b+vec3.b+vec4.b+vec5.b;
    normal[2] = vec1.c+vec2.c+vec3.c+vec4.c+vec5.c;
  
    float length = sqrt(normal[0]*normal[0]+normal[1]*normal[1]+normal[2]*normal[2]);

    normal[0] /= length;
    normal[1] /= length;
    normal[2] /= length;
  }
  
float LocalClient::LC(float col1,float col2)
{
  return col1<col2?col1:col2;
}  
