// little explanation how this server-client
// synchronistion works By default, when making
// a clock two values are set
// Maximum Server Time - how many ms the server has to make
// its voo-doo
// Minimum Client Time - minimum time for the client to do its magic
//
// now with 30 ms server and 10 ms client
// if the server finishes his work in less then 30 ms
// then the remaining time is given to the client
// example:
// the server finishes in 5 ms
// so client has (30-5)+10 = 35 ms to draw
// check controls etc
// once the client finishes the game waits untill the whole
// frame time passes
// 
// if the server exceeds its time (30 ms in our example)
// then the game gets slower for all clients
//
// if the client exceeds its time then it reports *frame drop*
// to the server.
//
// dropped frame will be drawn in the next client time, and the
// next thing to draw will be ignored

//##################################################
// clock class - take care of the sychronisation stuff
class Clock
{
  // how many ms for a single server frame
  int ServerTime;
  
  // how many ms elapsed since the beginning
  // of the frame
  int CurrentMs;
  
  // corrected ms for the ms
  // it is ClientTime + Bonus if the server finished
  // before ServerTime
  int ClientLimit;
  
  // time since beginning of the program work
  // AbsoluteTime + ServerTime + ClientTime =
  // = When do we have to finish.
  double AbsoluteTime;
  
public:

  // constructor
  Clock(int MaximumServerTime);
  
  // destructor
  ~Clock(void);
  
  // start the clock - before each frame
  void StartClock(void);
  
  // stop the server time measurement, return how many ms
  // to give to the client
  int StopServerClock(void);
};
