#include "server.h"
#include <iostream>
#include <stdlib.h>
#include <SDL/SDL.h>

using namespace std;

Server::Server(int MapSizex,int MapSizey)
{
    if(SDL_Init(SDL_INIT_VIDEO) == -1)
      {
        SDL_success = false;
      }
      else
      {
        SDL_success = true;
      }
    map = new GameMap(MapSizex,MapSizey);
    teclock = new Clock(30);
    calendar = new Calendar(1900,10);
    localclient = new LocalClient(10,map->Map,map->Heights,
                                  54,54,32,32,
                                  map->size_x,map->size_z);
    frame = 0;
    exit = false;
};

Server::~Server()
{
  delete map;
  delete teclock;
  delete calendar;
  delete localclient;
  SDL_Quit();
};

void Server::ProcessFrame()
{
  while(!exit)
    {
      frame ++;
      teclock->StartClock();
      calendar->NextDay();
      localclient->StartClientClock(teclock->StopServerClock());
      localclient->TestControls();
      for (int x = 0;x < 5;x++)
      {
        if (localclient->commands[x].code == 1)
          {        
            exit = true;
            localclient->commands[x].code = 0;
          };

        if (localclient->commands[x].code == 2)
          {
          switch (localclient->commands[x].par1)
            {
            case 1:
              map->edge-=0.1;
              localclient->commands[x].code = 0;
              break;
            case 2:
              map->edge+=0.1;
              localclient->commands[x].code = 0;
              break;
            case 3:
              map->amplitude+=0.01;
              localclient->commands[x].code = 0;
              break;
            case 4:
              map->amplitude-=0.01;
              localclient->commands[x].code = 0;
              break;
            };
          };  

         if (localclient->commands[x].code == 3)
           {
             map->RandomMap();
             localclient->commands[x].code = 0;
             localclient->CreateArrays();
           };  
           
      };
      localclient->Draw();
   };    
};
    
